Imports System.IO
Imports System.Text
Imports System.Xml
Imports System.Drawing.Imaging

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
        Friend WithEvents btnWriteXML As System.Windows.Forms.Button
    Friend WithEvents picSmiley As System.Windows.Forms.PictureBox
    Friend WithEvents txtResults As System.Windows.Forms.TextBox
    Friend WithEvents optBase64 As System.Windows.Forms.RadioButton
    Friend WithEvents optBinHex As System.Windows.Forms.RadioButton

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(Form1))
        Me.optBinHex = New System.Windows.Forms.RadioButton()
        Me.txtResults = New System.Windows.Forms.TextBox()
        Me.picSmiley = New System.Windows.Forms.PictureBox()
        Me.btnWriteXML = New System.Windows.Forms.Button()
        Me.optBase64 = New System.Windows.Forms.RadioButton()
        Me.SuspendLayout()
        '
        'optBinHex
        '
        Me.optBinHex.Location = New System.Drawing.Point(136, 32)
        Me.optBinHex.Name = "optBinHex"
        Me.optBinHex.Size = New System.Drawing.Size(72, 16)
        Me.optBinHex.TabIndex = 2
        Me.optBinHex.Text = "BinHex"
        '
        'txtResults
        '
        Me.txtResults.Location = New System.Drawing.Point(216, 8)
        Me.txtResults.Multiline = True
        Me.txtResults.Name = "txtResults"
        Me.txtResults.ScrollBars = System.Windows.Forms.ScrollBars.Both
        Me.txtResults.Size = New System.Drawing.Size(360, 296)
        Me.txtResults.TabIndex = 1
        Me.txtResults.Text = ""
        '
        'picSmiley
        '
        Me.picSmiley.Image = CType(resources.GetObject("picSmiley.Image"), System.Drawing.Bitmap)
        Me.picSmiley.Name = "picSmiley"
        Me.picSmiley.Size = New System.Drawing.Size(128, 128)
        Me.picSmiley.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize
        Me.picSmiley.TabIndex = 0
        Me.picSmiley.TabStop = False
        '
        'btnWriteXML
        '
        Me.btnWriteXML.Location = New System.Drawing.Point(136, 72)
        Me.btnWriteXML.Name = "btnWriteXML"
        Me.btnWriteXML.TabIndex = 0
        Me.btnWriteXML.Text = "Write XML"
        '
        'optBase64
        '
        Me.optBase64.Checked = True
        Me.optBase64.Location = New System.Drawing.Point(136, 8)
        Me.optBase64.Name = "optBase64"
        Me.optBase64.Size = New System.Drawing.Size(72, 16)
        Me.optBase64.TabIndex = 2
        Me.optBase64.TabStop = True
        Me.optBase64.Text = "Base64"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(616, 325)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.optBinHex, Me.optBase64, Me.txtResults, Me.btnWriteXML, Me.picSmiley})
        Me.Name = "Form1"
        Me.Text = "WriteEncodedPicture"
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' Save the picture into an XML file.
    Private Sub btnWriteXML_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWriteXML.Click
        Me.Cursor = Cursors.WaitCursor
        txtResults.Text = ""
        Refresh()

        ' Set the file name depending on the type of encoding.
        Dim file_name As String
        If optBase64.Checked Then
            file_name = DataSubdirectory() & "\PictureBase64.xml"
        Else
            file_name = DataSubdirectory() & "\PictureBinHex.xml"
        End If

        ' Make an XmlTextWriter attached to this file.
        Dim xml_text_writer As New XmlTextWriter(file_name, Encoding.UTF8)

        ' Start the document.
        xml_text_writer.Formatting = Formatting.Indented
        xml_text_writer.WriteStartDocument()

        ' Make a Picture element.
        xml_text_writer.WriteStartElement("Picture")

        ' Save the encoding type in an attribute.
        If optBase64.Checked Then
            xml_text_writer.WriteAttributeString("Encoding", Nothing, "Base64")
        Else
            xml_text_writer.WriteAttributeString("Encoding", Nothing, "BinHex")
        End If

        ' Copy the picture into a MemoryStream.
        Dim memory_stream As New MemoryStream()
        picSmiley.Image.Save(memory_stream, ImageFormat.Bmp)

        ' Copy the MemoryStream data into a Byte array.
        Dim bytes(memory_stream.Length - 1) As Byte
        bytes = memory_stream.ToArray()

        ' Save the array's length in an attribute.
        xml_text_writer.WriteAttributeString("NumBytes", Nothing, bytes.Length)

        ' Write the byte data into the XML document.
        If optBase64.Checked Then
            xml_text_writer.WriteBase64(bytes, 0, bytes.Length)
        Else
            xml_text_writer.WriteBinHex(bytes, 0, bytes.Length)
        End If

        ' Finish the Picture element.
        xml_text_writer.WriteEndElement()

        ' Finish the XML document.
        xml_text_writer.WriteEndDocument()
        xml_text_writer.Close()

        ' Display the results.
        txtResults.Text = GetFileContents(file_name)
        txtResults.Select(0, 0)

        Me.Cursor = Cursors.Default
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        Dim wid As Integer

        wid = ClientSize.Width - txtResults.Location.X
        If wid < 10 Then wid = 10
        txtResults.SetBounds(txtResults.Location.X, 0, wid, ClientSize.Height)
    End Sub
End Class
